(function (_, kotlin_clikt_clikt, kotlin_kotlin, kotlin_mordant_mordant) {
  'use strict';
  //region block: imports
  var CoreCliktCommand = kotlin_clikt_clikt.$_$.a;
  var VOID = kotlin_kotlin.$_$.g;
  var Unit_instance = kotlin_kotlin.$_$.i3;
  var protoOf = kotlin_kotlin.$_$.q8;
  var initMetadataForClass = kotlin_kotlin.$_$.r7;
  var selfAndAncestors = kotlin_clikt_clikt.$_$.e;
  var mapNotNull = kotlin_kotlin.$_$.r9;
  var firstOrNull = kotlin_kotlin.$_$.m9;
  var Terminal_init_$Create$ = kotlin_mordant_mordant.$_$.g;
  var last = kotlin_kotlin.$_$.q9;
  var MultiplatformSystem_instance = kotlin_mordant_mordant.$_$.i;
  var FileNotFound = kotlin_clikt_clikt.$_$.b;
  var Terminal = kotlin_mordant_mordant.$_$.b;
  var Whitespace_NORMAL_getInstance = kotlin_mordant_mordant.$_$.e;
  var Text_init_$Create$ = kotlin_mordant_mordant.$_$.h;
  var AbstractHelpFormatter = kotlin_clikt_clikt.$_$.g;
  var verticalLayout = kotlin_mordant_mordant.$_$.a;
  var charSequenceLength = kotlin_kotlin.$_$.h7;
  var definitionList = kotlin_mordant_mordant.$_$.c;
  var withPadding = kotlin_mordant_mordant.$_$.d;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.f4;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.k;
  var ensureNotNull = kotlin_kotlin.$_$.nc;
  var drop = kotlin_kotlin.$_$.ca;
  var plus = kotlin_kotlin.$_$.tc;
  var Whitespace_PRE_WRAP_getInstance = kotlin_mordant_mordant.$_$.f;
  var isBlank = kotlin_kotlin.$_$.ia;
  var replace = kotlin_kotlin.$_$.ta;
  //endregion
  //region block: pre-declaration
  initMetadataForClass(CliktCommand, 'CliktCommand', VOID, CoreCliktCommand);
  initMetadataForClass(MordantHelpFormatter, 'MordantHelpFormatter', VOID, AbstractHelpFormatter);
  //endregion
  function CliktCommand(name) {
    name = name === VOID ? null : name;
    CoreCliktCommand.call(this, name);
    installMordant(this);
  }
  function installMordant(_this__u8e3s4, force) {
    force = force === VOID ? false : force;
    _this__u8e3s4.h1i(installMordant$lambda(force));
  }
  function get_terminal(_this__u8e3s4) {
    // Inline function 'com.github.ajalt.clikt.core.Context.findObject' call
    var key = 'mordant_terminal';
    var tmp = selfAndAncestors(_this__u8e3s4);
    var tmp0_elvis_lhs = firstOrNull(mapNotNull(tmp, _get_terminal_$lambda_5keric(key)));
    var tmp_0;
    if (tmp0_elvis_lhs == null) {
      // Inline function 'kotlin.also' call
      var this_0 = Terminal_init_$Create$();
      // Inline function 'com.github.ajalt.clikt.core.<get-terminal>.<anonymous>' call
      var tmp0 = last(selfAndAncestors(_this__u8e3s4)).f1g_1;
      // Inline function 'kotlin.collections.set' call
      var key_0 = 'mordant_terminal';
      tmp0.e2(key_0, this_0);
      tmp_0 = this_0;
    } else {
      tmp_0 = tmp0_elvis_lhs;
    }
    return tmp_0;
  }
  function installMordant$lambda$lambda(it) {
    return new MordantHelpFormatter(it);
  }
  function installMordant$lambda$lambda_0(it) {
    return MultiplatformSystem_instance.c24(it);
  }
  function installMordant$lambda$lambda_1(it) {
    var tmp0_elvis_lhs = MultiplatformSystem_instance.e24(it);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      throw new FileNotFound(it);
    } else {
      tmp = tmp0_elvis_lhs;
    }
    return tmp;
  }
  function installMordant$lambda$lambda_2(it) {
    MultiplatformSystem_instance.d24(it);
    return Unit_instance;
  }
  function installMordant$lambda$lambda_3(context, message, trailingNewline, err) {
    if (trailingNewline) {
      get_terminal(context).c2e(message, VOID, VOID, VOID, VOID, err);
    } else {
      get_terminal(context).a2e(message, VOID, VOID, VOID, VOID, err);
    }
    return Unit_instance;
  }
  function installMordant$lambda($force) {
    return function ($this$configureContext) {
      var tmp;
      if (!$force && !($this$configureContext.i1i_1 == null)) {
        return Unit_instance;
      }
      var tmp_0 = $this$configureContext;
      tmp_0.n1i_1 = installMordant$lambda$lambda;
      var tmp_1 = $this$configureContext;
      tmp_1.v1i_1 = installMordant$lambda$lambda_0;
      var tmp_2 = $this$configureContext;
      tmp_2.q1i_1 = installMordant$lambda$lambda_1;
      var tmp_3 = $this$configureContext;
      tmp_3.y1i_1 = installMordant$lambda$lambda_2;
      var tmp_4 = $this$configureContext;
      tmp_4.x1i_1 = installMordant$lambda$lambda_3;
      return Unit_instance;
    };
  }
  function _get_terminal_$lambda_5keric($key) {
    return function (it) {
      var tmp = it.f1g_1.w1($key);
      return tmp instanceof Terminal ? tmp : null;
    };
  }
  function MordantHelpFormatter$formatHelp$lambda(this$0, $error, $prolog, $epilog, $parameters, $programName) {
    return function ($this$verticalLayout) {
      $this$verticalLayout.s2a(1);
      $this$verticalLayout.p2a(this$0.q1o($error, $prolog, $epilog, $parameters, $programName));
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderUsage$lambda($prog, $usageParts) {
    return function ($this$definitionList) {
      $this$definitionList.m2e($prog, Text_init_$Create$($usageParts, Whitespace_NORMAL_getInstance()));
      $this$definitionList.g2e_1 = true;
      $this$definitionList.j2e(1);
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderProlog$lambda($this$withPadding) {
    $this$withPadding.p2c_1 = 2;
    return Unit_instance;
  }
  function MordantHelpFormatter$renderParameters$lambda(this$0, $parameters) {
    return function ($this$definitionList) {
      var _iterator__ex2g4s = this$0.d1q($parameters).m();
      while (_iterator__ex2g4s.n()) {
        var section = _iterator__ex2g4s.o();
        $this$definitionList.m2e(section.x1n_1, section.y1n_1);
      }
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderOptionGroup$lambda($this$withPadding) {
    $this$withPadding.m2c_1 = 1;
    $this$withPadding.p2c_1 = 2;
    $this$withPadding.o2c_1 = 1;
    return Unit_instance;
  }
  function MordantHelpFormatter$renderOptionGroup$lambda_0($markdown, this$0, $options) {
    return function ($this$verticalLayout) {
      $this$verticalLayout.r2a($markdown);
      $this$verticalLayout.r2a(this$0.n1q($options));
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$buildParameterList$lambda($rows, this$0) {
    return function ($this$definitionList) {
      $this$definitionList.g2e_1 = true;
      var _iterator__ex2g4s = $rows.m();
      while (_iterator__ex2g4s.n()) {
        var row = _iterator__ex2g4s.o();
        $this$definitionList.n2e(this$0.i1r(row), this$0.j1r(row));
      }
      return Unit_instance;
    };
  }
  function MordantHelpFormatter(context, requiredOptionMarker, showDefaultValues, showRequiredTag) {
    requiredOptionMarker = requiredOptionMarker === VOID ? null : requiredOptionMarker;
    showDefaultValues = showDefaultValues === VOID ? false : showDefaultValues;
    showRequiredTag = showRequiredTag === VOID ? false : showRequiredTag;
    AbstractHelpFormatter.call(this, context, requiredOptionMarker, showDefaultValues, showRequiredTag);
  }
  protoOf(MordantHelpFormatter).r2f = function () {
    return get_terminal(this.e1o_1).m27_1;
  };
  protoOf(MordantHelpFormatter).b1i = function (error, prolog, epilog, parameters, programName) {
    var widget = verticalLayout(MordantHelpFormatter$formatHelp$lambda(this, error, prolog, epilog, parameters, programName));
    return get_terminal(this.e1o_1).d2e(widget);
  };
  protoOf(MordantHelpFormatter).s1o = function (parameters, error) {
    return Text_init_$Create$(this.w1o(parameters, error));
  };
  protoOf(MordantHelpFormatter).r1o = function (parameters, programName) {
    var title = this.s2f(this.p1o().d1r());
    var prog = title + ' ' + programName;
    var usageParts = this.a1p(parameters);
    var tmp;
    // Inline function 'kotlin.text.isEmpty' call
    if (charSequenceLength(usageParts) === 0) {
      tmp = Text_init_$Create$(prog, Whitespace_NORMAL_getInstance());
    } else {
      tmp = definitionList(MordantHelpFormatter$renderUsage$lambda(prog, usageParts));
    }
    return tmp;
  };
  protoOf(MordantHelpFormatter).t1o = function (prolog) {
    var tmp = this.t2f(prolog);
    return withPadding(tmp, false, MordantHelpFormatter$renderProlog$lambda);
  };
  protoOf(MordantHelpFormatter).v1o = function (epilog) {
    return this.t2f(epilog);
  };
  protoOf(MordantHelpFormatter).u1o = function (parameters) {
    return definitionList(MordantHelpFormatter$renderParameters$lambda(this, parameters));
  };
  protoOf(MordantHelpFormatter).b1q = function (help, parameters) {
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(parameters, 10));
    var _iterator__ex2g4s = parameters.m();
    while (_iterator__ex2g4s.n()) {
      var item = _iterator__ex2g4s.o();
      // Inline function 'com.github.ajalt.clikt.output.MordantHelpFormatter.renderOptionGroup.stub_for_inlining' call
      var tmp$ret$0 = this.g1q(item);
      destination.e(tmp$ret$0);
    }
    var options = destination;
    if (help == null)
      return this.n1q(options);
    var tmp = this.t2f(help);
    var markdown = withPadding(tmp, false, MordantHelpFormatter$renderOptionGroup$lambda);
    return verticalLayout(MordantHelpFormatter$renderOptionGroup$lambda_0(markdown, this, options));
  };
  protoOf(MordantHelpFormatter).m1o = function (name) {
    // Inline function 'kotlin.text.lowercase' call
    // Inline function 'kotlin.js.asDynamic' call
    return '<' + name.toLowerCase() + '>';
  };
  protoOf(MordantHelpFormatter).l1q = function (name) {
    return this.r2f().b27('danger').a20(name);
  };
  protoOf(MordantHelpFormatter).u1q = function (name) {
    return this.r2f().b27('muted').a20(name);
  };
  protoOf(MordantHelpFormatter).k1o = function (name) {
    return this.r2f().b27('info').a20(name);
  };
  protoOf(MordantHelpFormatter).n1o = function (name) {
    return this.r2f().b27('info').a20(name);
  };
  protoOf(MordantHelpFormatter).o1o = function (name) {
    return this.r2f().b27('info').a20(name);
  };
  protoOf(MordantHelpFormatter).c1q = function (title) {
    return this.r2f().b27('warning').a20(title);
  };
  protoOf(MordantHelpFormatter).s2f = function (title) {
    return this.r2f().b27('warning').a20(title);
  };
  protoOf(MordantHelpFormatter).y1o = function (title) {
    return this.r2f().b27('danger').a20(title);
  };
  protoOf(MordantHelpFormatter).d1p = function (parameter) {
    return this.r2f().b27('muted').a20(parameter);
  };
  protoOf(MordantHelpFormatter).w1q = function (metavar) {
    return this.r2f().b27('warning').p23(this.r2f().b27('muted')).a20(metavar);
  };
  protoOf(MordantHelpFormatter).i1r = function (row) {
    var tmp;
    // Inline function 'kotlin.text.isNullOrEmpty' call
    var this_0 = row.b1o_1;
    if (this_0 == null || charSequenceLength(this_0) === 0) {
      tmp = '  ';
    } else {
      // Inline function 'kotlin.text.ifEmpty' call
      var this_1 = drop('  ', ensureNotNull(row.b1o_1).length);
      var tmp_0;
      // Inline function 'kotlin.text.isEmpty' call
      if (charSequenceLength(this_1) === 0) {
        // Inline function 'com.github.ajalt.clikt.output.MordantHelpFormatter.renderDefinitionTerm.<anonymous>' call
        tmp_0 = ' ';
      } else {
        tmp_0 = this_1;
      }
      var tmp$ret$3 = tmp_0;
      tmp = plus(row.b1o_1, tmp$ret$3);
    }
    var termPrefix = tmp;
    return Text_init_$Create$(termPrefix + row.z1n_1, Whitespace_PRE_WRAP_getInstance());
  };
  protoOf(MordantHelpFormatter).j1r = function (row) {
    return isBlank(row.a1o_1) ? Text_init_$Create$('') : this.t2f(row.a1o_1);
  };
  protoOf(MordantHelpFormatter).n1q = function (rows) {
    return definitionList(MordantHelpFormatter$buildParameterList$lambda(rows, this));
  };
  protoOf(MordantHelpFormatter).t2f = function (text) {
    return Text_init_$Create$(replace(text, '\n\n', '\x85\x85'), Whitespace_NORMAL_getInstance());
  };
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = CliktCommand;
  //endregion
  return _;
}(module.exports, require('./clikt-clikt.js'), require('./kotlin-kotlin-stdlib.js'), require('./mordant-mordant.js')));

//# sourceMappingURL=clikt-clikt-mordant.js.map
